from FilterManager import *

def test_median():
    image = tifffile.imread('/media/winHDD/hparks/rec20160525_165348_holland_polar_bear_hair_1.tif')
    image = scale_to_uint8(image)
    platforms = ClAttributes.list_all_cl_platforms()
    d = {}
    for p in platforms:
        d[p] = 100

    # image = run_MedianFilter(image, platform=d, radius=10)
    image = run_MedianFilter(image, ClAttributes.list_all_cl_platforms()[0])
    tifffile.imsave('/media/winHDD/hparks/median.tif', image)

def test_fft():
    image = tifffile.imread('/media/winHDD/hparks/rec20160525_165348_holland_polar_bear_hair_1.tif')
    image = scale_to_uint8(image)

    # im = run_FFTFilter(image, platform=ClAttributes.list_all_cl_platforms()[-1])
    im = run_FFTFilter(image, platform=ClAttributes.list_all_cl_platforms()[0])
    tifffile.imsave('/media/winHDD/hparks/fft.tif', im)

def test_bilateral():
    image = tifffile.imread('/media/winHDD/hparks/rec20160525_165348_holland_polar_bear_hair_1.tif')
    image = scale_to_uint8(image)

    im = run_BilateralFilter(image, 3, 30)
    tifffile.imsave('/media/winHDD/hparks/bilateral.tif', im)

def test_mask():
    image = tifffile.imread('/media/winHDD/hparks/rec20160525_165348_holland_polar_bear_hair_1.tif')
    image = scale_to_uint8(image)[:100]

    mask = np.zeros((100,352,275))

    im = run_MaskFilter(image, mask=mask)
    tifffile.imsave('/media/winHDD/hparks/maskfilter.tif', im)

def test_mmdil():
    image = tifffile.imread('/media/winHDD/hparks/rec20160525_165348_holland_polar_bear_hair_1.tif')
    image = scale_to_uint8(image)
    platforms = ClAttributes.list_all_cl_platforms()
    d = {}
    for p in platforms:
        d[p] = 75


    im = run_MMFilterDil(image, mask='StructuredElementL', platform=d)
    tifffile.imsave('/media/winHDD/hparks/mmdil2.tif', im)

def test_mmero():
    image = tifffile.imread('/media/winHDD/hparks/rec20160525_165348_holland_polar_bear_hair_1.tif')
    image = scale_to_uint8(image)

    im = run_MMFilterEro(image, mask='Diagonal10x10x10')
    tifffile.imsave('/media/winHDD/hparks/mmero.tif',im)

def test_mmclo():
    image = tifffile.imread('/media/winHDD/hparks/rec20160525_165348_holland_polar_bear_hair_1.tif')
    image = scale_to_uint8(image)

    im = run_MMFilterClo(image, mask='StructuredElementL')
    tifffile.imsave('/media/winHDD/hparks/mmclo.tif', im)

def test_mmope():
    import time
    image = tifffile.imread('/media/winHDD/hparks/rec20160525_165348_holland_polar_bear_hair_1.tif')
    image = scale_to_uint8(image)

    im = run_MMFilterOpe(image, mask='Diagonal10x10x4')
    tifffile.imsave('/media/winHDD/hparks/mmope.tif', im)

def test_pipeline():

    image = tifffile.imread('/media/winHDD/hparks/rec20160525_165348_holland_polar_bear_hair_1.tif')
    image = scale_to_uint8(image)

    pipeline = [mmope.MMFilterOpe(), mf.MedianFilter(),]
    im = run_f3d(image, pipeline, platform=ClAttributes.list_all_cl_platforms()[0])
    # im = run_f3d(image, pipeline)

    tifffile.imsave('/media/winHDD/hparks/pipeline.tif', im)


if __name__ == '__main__':
    import tifffile

    import os
    os.environ['PYOPENCL_COMPILER_OUTPUT'] = '1'

    test_median()
    # test_pipeline()
    # test_bilateral()
    # test_fft()
    # test_mask()
    # test_mmdil()
    # test_mmero()
    # test_mmclo()
    # test_mmope()
